Public Class Form1
    Private lvwBooks As ListViewWithIcons

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make the ListViewWithIcons.
        lvwBooks = New ListViewWithIcons()
        Me.Controls.Add(lvwBooks)

        lvwBooks.SmallImageList = imlIcons
        lvwBooks.Dock = DockStyle.Fill
        lvwBooks.View = View.Details

        ' Make the column headers.
        ListViewMakeColumnHeaders(lvwBooks, _
            "Title", 230, HorizontalAlignment.Left, _
            "URL", 220, HorizontalAlignment.Left, _
            "ISBN", 130, HorizontalAlignment.Left, _
            "Picture", 230, HorizontalAlignment.Left, _
            "Pages", 50, HorizontalAlignment.Right, _
            "Year", 60, HorizontalAlignment.Right)

        ' Add data rows.
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Algorithms", "http://www.vb-helper.com/vba.htm", "0-471-24268-3", "http://www.vb-helper.com/vba.jpg", "395", "1998")
        ListViewMakeRow(lvwBooks, "Visual Basic Graphics Programming", "http://www.vb-helper.com/vbgp.htm", "0-472-35599-2", "http://www.vb-helper.com/vbgp.jpg", "712", "2000")
        ListViewMakeRow(lvwBooks, "Advanced Visual Basic Techniques", "http://www.vb-helper.com/avbt.htm", "0-471-18881-6", "http://www.vb-helper.com/avbt.jpg", "440", "1997")
        ListViewMakeRow(lvwBooks, "Custom Controls Library", "http://www.vb-helper.com/ccl.htm", "0-471-24267-5", "http://www.vb-helper.com/ccl.jpg", "684", "1998")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Delphi Algorithms", "http://www.vb-helper.com/da.htm", "0-471-25400-2", "http://www.vb-helper.com/da.jpg", "398", "1998")
        ListViewMakeRow(lvwBooks, "Bug Proofing Visual Basic", "http://www.vb-helper.com/err.htm", "0-471-32351-9", "http://www.vb-helper.com/err.jpg", "397", "1999")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Code Library", "http://www.vb-helper.com/vbcl.htm", "0-471-33345-X", "http://www.vb-helper.com/vbcl.jpg", "424", "1999")

        For r As Integer = 0 To lvwBooks.Items.Count - 1
            For c As Integer = 0 To lvwBooks.Columns.Count - 1
                lvwBooks.AddIconToSubitem(r, c, c)
            Next c
        Next r
    End Sub

    ' Make the ListView's column headers.
    ' The ParamArray entries should alternate between
    ' strings and HorizontalAlignment values.
    Private Sub ListViewMakeColumnHeaders(ByVal lvw As _
        ListView, ByVal ParamArray header_info() As Object)
        ' Remove any existing headers.
        lvw.Columns.Clear()

        ' Make the column headers.
        For i As Integer = header_info.GetLowerBound(0) To _
            header_info.GetUpperBound(0) Step 3
            lvw.Columns.Add( _
                DirectCast(header_info(i), String), _
                DirectCast(header_info(i + 1), Integer), _
                DirectCast(header_info(i + 2), _
                    HorizontalAlignment))
        Next i
    End Sub

    ' Make a ListView row.
    Private Sub ListViewMakeRow(ByVal lvw As ListView, ByVal item_title As String, ByVal ParamArray subitem_titles() As String)
        ' Make the item.
        Dim new_item As ListViewItem = lvw.Items.Add(item_title, 1)

        ' Make the sub-items.
        For i As Integer = subitem_titles.GetLowerBound(0) To subitem_titles.GetUpperBound(0)
            new_item.SubItems.Add(subitem_titles(i))
        Next i
    End Sub
End Class
